package sk.geneton.triglav.correction;

import java.util.ArrayList;

public class CorrectedReadCounts {
	
	String chName;
	
	int[] uncorrected;	//from SamFileContents.contents (int[]) na bin <index> sa namapovalo <hodnota> citani 
	double[] corrected;
	double[] loessValues;
	int readCount;
	int binCount;	//number of bins in this chromosome, to which some number of reads (>0) was mapped 
	ArrayList<BinContent> contentList; //from GcContents.contentMap.get(chrName)
	double correctedSum;
	
	
	/*
	 * potrebujem neopravene pocty citani pre dany chromozom,
	 * obsah GC pre dany chromozom a bin (GcContents), aby som mohla zisitit, ktoru hodnotu z loessa potrebujem,
	 * hodnoty z loessa (kvoli vzorcu),
	 * celkovy pocet citani v chromozome, pocet binov v chromozome (kvoli vzorcu)
	 *  
	 */
	
	
	CorrectedReadCounts(int[] uncorr, double[] loess, int reads, int bins, ArrayList<BinContent> list){
		this.uncorrected = uncorr;
		this.loessValues = loess;
		this.readCount = reads;
		this.binCount = bins;
		this.contentList = list;
		this.corrected = new double[uncorr.length];
		this.correctedSum = -1;
	}
	
	void correct(){
		
		double expected_val = (double)this.readCount/this.binCount;
		for (int i = 0; i < uncorrected.length; i++){
			if (uncorrected[i] == 0){
				corrected[i] = 0;
			} else {
				BinContent c = contentList.get(i);
				double gcBinPercentage = c.GcContent;
				int index = (int)(gcBinPercentage*10);				
				corrected[i] = uncorrected[i] - (this.loessValues[index] - expected_val);
			}
		}
		double sum = 0;
		for (int i = 0; i < this.corrected.length; i++){
			sum += this.corrected[i];
		}
		this.correctedSum = sum;
	}
	
}
