package sk.geneton.triglav.correction;

import java.util.ArrayList;
import java.util.HashMap;

/*
 * Struktura, ktora uchovava GC obsah jednej vzorky v HashMap contentMap.
 * Obsahuje dvojicu [kluc,hodnota] pre kazdy chromozom. Kluc je nazov chromozomu 
 * (String, napr. chr1)
 * Hodnota je arraylist, ktory pre kazdy bin obsahuje Content - pomer GC a N baz 
 * (ArrayList[0] obsahuje content pre nulty (prvy) bin) 
 */

public class GcContents {
	
	private int binSize;
	HashMap<String,ArrayList<BinContent>> contentMap;
	
	GcContents(){
		this.binSize = -1;
	}
	
	ArrayList<BinContent> returnChrContents(String chrName){
		
		ArrayList<BinContent> list = contentMap.get(chrName);
		return list;
	}
	
	
	/*
	 * vrati pomer obsahu N baz na chromozome chr a bine bin
	 * vrati -1 ak sa pozadovany pomer nenajde
	 */
	double getN(String chr, int bin){ 
		
		ArrayList<BinContent> values = contentMap.get(chr);
		if (values == null){
			return -1;
		}
		BinContent content = values.get(bin);
		if (content == null){
			return -1;
		}
		return content.NContent;
		
	}
	
	void setBinSize(int size){
		this.binSize = size;
	}
	
	int getBinSize(){
		return this.binSize;
	}
	
	/*
	 * vrati pomer obsahu GC baz na chromozome chr a bine bin
	 * vrati -1 ak sa pozadovany pomer nenajde
	 */
	double getGC(String chr, int bin){
		
		ArrayList<BinContent> values = contentMap.get(chr);
		if (values == null){
			return -1;
		}
		BinContent content = values.get(bin);
		if (content == null){
			return -1;
		}
		return content.GcContent;
		
	}
	
}
