package sk.geneton.triglav.correction;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

import org.apache.commons.math3.analysis.interpolation.LoessInterpolator;

import net.sf.samtools.SAMFileReader;
import net.sf.samtools.SAMRecord;
import net.sf.samtools.SAMRecordIterator;

public class RunClass {

	static ArrayList<Double> load(){
		ArrayList<Double> list = new ArrayList<Double>();
		File f = new File("avg.txt");
		try {
			Scanner s = new Scanner(f);
			
			while (s.hasNext()){
				String first_d = s.next();
				s.next(); //hyphen
				s.next(); //interpolated
				Double d = Double.parseDouble(first_d);
				list.add(d);
			}
			
			System.out.println("List ma "+list.size()+"elementov");
			for (int i = 0; i < list.size(); i++){
				System.out.println(list.get(i));
			}
			
			s.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return list;
		
	}
	
	public static void main(String[] args) {
		
		LoessInterpolator interpolator = new LoessInterpolator();
		
		double[] xval = new double[100];
		for (int i = 0; i < 100; i++){
			xval[i] = i;
		}
		System.out.println("y values: ");
		double[] yval = new double[100];
		for (int i = 0; i < 100; i++){
			yval[i] = 10 + Math.random();
		}
		yval[1] = 0;
		yval[2] = 0;
		yval[3] = 0;
		yval[8] = 0;
		yval[9] = 0;
		yval[10] = 0;
		
		for (int i = 0; i < 100; i++){
			System.out.println(i+". "+yval[i]);
		}
		
		double[] weights = new double[100];
		for (int i = 0; i < 100; i++){
			weights[i] = 0;
		}
		int pom;
		
		System.out.println("weights: ");
		for (int i = 5; i < 100; i++){
			pom = (int) Math.round(Math.random() * 10);
			weights[i] = pom;
		}
		
		/*double sum = 0;
		for (int i = 0; i < 100; i++){
			sum += weights[i];
		}
		for (int i = 0; i < 100; i++){
			weights[i] = weights[i]/sum;
		}*/
		
		for (int i = 0; i < 100; i++){
			System.out.println(i+". "+weights[i]);
		}
		
		double[] result = interpolator.smooth(xval, yval);
		System.out.println("result: ");
		for (int i = 0; i < result.length; i++){
			System.out.println(i+". "+result[i]);
		}
		
		

	}

}
